﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using Utility;
using KillingManager;
using DAL;
using System.Threading;
using KillingClientUI;

namespace ServerLib
{
    // NOTE: If you change the class name "MessageDistribute" here, you must also update the reference to "MessageDistribute" in Web.config.
    [ServiceBehavior]
    public partial class MessageDistribute : IMessageDistribute
    {
        //Save current game 
        public static Game CurrentGame = null;//new Game();
        //Save current Activity
        public static Activity CurrentActivity = null;//new Activity();
        //All Player Count
        public static int AllPlayersCount;

        //Player client -> Server host
        [OperationBehavior]
        public bool DistribChatMsg(ChatFormat chat)
        {

            //If the game has not been started.
            if (CurrentGame == null)
            {
                IList<User> listPlayerOnline = Business.GetUser(IsOnlineFlag.Online);
                foreach (User player in listPlayerOnline)
                {
                    string strMsg = chat.Sender+ " says: " + chat.MsgBody;
                    SendMessageThread(player.IP, strMsg);
                }

                return true;
            }
            //TODO:
            //Day Time

            //Player player = GetPlayerInfo(chat.Sender);
            Player pig = Business.GetPlayer(chat.Sender, CurrentGame);
            IList<PlayerEntity> listPlayers = null;


            if (GetCurrentTimeFlag() == TimeFlag.DayTime)
            {
                listPlayers = Business.GetPlayerEntities(RoleFlag.Civilian | RoleFlag.Killer | RoleFlag.Police, IsActiveFlag.Active, CurrentGame);
            }
            else
            {
                if (pig.RoleID == (int)RoleFlag.Killer)
                    listPlayers = Business.GetPlayerEntities(RoleFlag.Killer, IsActiveFlag.Active, CurrentGame);
            }

            if (listPlayers == null)
                return true;

            foreach (PlayerEntity play in listPlayers)
            {
                string ip = play.IP;
                string sender = chat.Sender;
                string mesgbody = chat.MsgBody;
                Thread workerThread = new Thread(()=>
                {
                    ConnectToServer(ip).ReceiveNewsMsg(sender + " says: " + mesgbody);
                });
                workerThread.Start();
            }

            return true;
        }

        private void SendMessageThread(string IP, string strMsg)
        {
            string ip = IP;
            string strMessage = strMsg;
            MessageDistribution proxyClientHost = ConnectToServer(ip);
            Thread workerThread = new Thread(()=>
            {
                proxyClientHost.ReceiveNewsMsg(strMessage);
            });
            workerThread.Start();
            return;
        }

        public TimeFlag GetCurrentTimeFlag()
        {
            if (CurrentActivity.ActivityTypeID == (int)ActivityTypeFlag.Vote)
                return TimeFlag.DayTime;
            else if ((CurrentActivity.ActivityTypeID == (int)ActivityTypeFlag.Kill) ||
                (CurrentActivity.ActivityTypeID == (int)ActivityTypeFlag.Investigate))
                return TimeFlag.Night;
            else return TimeFlag.DayTime;
        }

        public TimeFlag GetNextActivityTimeFlag()
        {
            if (CurrentActivity.ActivityTypeID == (int)ActivityTypeFlag.Vote)
                return TimeFlag.Night;
            else if ((CurrentActivity.ActivityTypeID == (int)ActivityTypeFlag.Kill) ||
                (CurrentActivity.ActivityTypeID == (int)ActivityTypeFlag.Investigate))
                return TimeFlag.DayTime;
            else return TimeFlag.DayTime;
        }



        //If vote is finished, return the dead person's name
        //Elese return "";
        public User SaveVote(VoteFormat vote)
        {
            return null;
        }

        //Player client -> Server host
        //The return value is the name who is killed.
        [OperationBehavior]
        public bool DistribVoteMsg(VoteFormat voteFormate)
        {
            MessageDistribution proxyClientHost = null;
            //TODO:
            //Fulfill the vote into database
            //Send message to everyone
            IList<PlayerEntity> listPlayers = null;
            Vote vote = new Vote();
            vote.Voter = voteFormate.Voter;
            vote.Candidate = voteFormate.Condidate;
            vote.ActivityNo = CurrentActivity.ActivityNo;
            vote.RoundNo = CurrentActivity.RoundCount;

            List<PlayerEntity> listCondidates =  Business.Vote(vote, CurrentActivity);


            //Notice to everyone somebody has voted.
            if(GetCurrentTimeFlag() == TimeFlag.DayTime)
                listPlayers = Business.GetPlayerEntities(RoleFlag.Civilian | RoleFlag.Killer | RoleFlag.Police, IsActiveFlag.Active | IsActiveFlag.Dead, CurrentGame);
            else
                listPlayers = Business.GetPlayerEntities(RoleFlag.Killer, IsActiveFlag.Active, CurrentGame);
            foreach (PlayerEntity play in listPlayers)
            {
                SendMessageThread(play.IP, "Judger says: " + voteFormate.Voter+ " has already voted!");
            }

            //if select one to be killed
            #region if count = 1;
            if (listCondidates.Count == 1)
            {
                VoteResult voteResult = new VoteResult();
                voteResult.IsThisVoteValid = true;
                voteResult.TimeFlag = GetNextActivityTimeFlag();

                listPlayers = Business.GetPlayerEntities(RoleFlag.Civilian | RoleFlag.Killer | RoleFlag.Police, IsActiveFlag.Active | IsActiveFlag.Dead, CurrentGame);
                foreach (PlayerEntity play in listPlayers)
                {
                    proxyClientHost = ConnectToServer(play.IP);
                    voteResult.KilledPlayer = listCondidates[0].UserID;
                    voteResult.ActiveTypeFlag = GetNextActivityType(true);
                    voteResult.TimeFlag = GetNextActivityTimeFlag();
                    voteResult.IsThisVoteValid = true;
                    proxyClientHost.ReceiveVoteResult(voteResult);


                    if (play.UserID == listCondidates[0].UserID)
                    {
                        SendMessageThread(play.IP, "Judger says: " + listCondidates[0].UserID + ", You are killed!");
                    }
                    else
                    {
                        SendMessageThread(play.IP, "Judger says: " + listCondidates[0].UserID + " is killed!");
                    }
                }

                //Game over
                //listPlayers.Remove(listPlayers.Select(c => c.PlayerID == listCondidates[0].PlayerID).Single());
                int i=0;
                for(i = 0; i < listPlayers.Count; i++)
                {
                    if (listPlayers[i].UserID == listCondidates[0].UserID)
                        break;
                }
                listPlayers.RemoveAt(i);
                
                //listPlayers.Select(p=>p.PlayerID==listCondidates[0].PlayerID)
                if(listPlayers.Select(c=>c.RoleID).Distinct().Count() <= 1)
                {
                    foreach (PlayerEntity play in listPlayers)
                    {
                        SendMessageThread(play.IP, "Judger says: Game over!" + ((RoleFlag)play.RoleID).ToString() + " wins this game!");
                    }
                    SendMessageThread(listCondidates[0].IP, "Judger says: Game over!" + ((RoleFlag)listPlayers[0].RoleID).ToString() + " wins this game!");


                    return true;
                }
                


                //Enter into next activity
                if ((ActivityTypeFlag)CurrentActivity.ActivityTypeID == ActivityTypeFlag.Vote)
                {
                    listPlayers = Business.GetPlayerEntities(RoleFlag.Civilian | RoleFlag.Killer | RoleFlag.Police, IsActiveFlag.Active, CurrentGame);
                    foreach (PlayerEntity play in listPlayers)
                    {
                        SendMessageThread(play.IP, "Judger says: Voting end, this is night, killers will kill somebody!");
                    }
                    CurrentActivity = Business.CreateNewActivity(CurrentGame);//, ActivityTypeFlag.Kill);
                }
                else if ((ActivityTypeFlag)CurrentActivity.ActivityTypeID == ActivityTypeFlag.Kill)
                {
                    listPlayers = Business.GetPlayerEntities(RoleFlag.Civilian | RoleFlag.Killer | RoleFlag.Police, IsActiveFlag.Active, CurrentGame);

                    foreach (PlayerEntity play in listPlayers)
                    {
                        SendMessageThread(play.IP, "Judger says: Killing end, this is night, vote anyone who you think is killer!");
                    }
                    CurrentActivity = Business.CreateNewActivity(CurrentGame);//, ActivityTypeFlag.Vote);
                }

                else if ((ActivityTypeFlag)CurrentActivity.ActivityTypeID == ActivityTypeFlag.Kill)
                {
                    listPlayers = Business.GetPlayerEntities(RoleFlag.Civilian | RoleFlag.Killer | RoleFlag.Police, IsActiveFlag.Active, CurrentGame);

                    foreach (PlayerEntity play in listPlayers)
                    {
                        SendMessageThread(play.IP, "Judger says: Investigating end, this is daytime, vote anyone who you think is killer!");
                    }
                    CurrentActivity = Business.CreateNewActivity(CurrentGame);//, ActivityTypeFlag.Vote);
                }
            }
            #endregion
            //if select more than one to be killed
            #region if Count > 1
            else if (listCondidates.Count > 1)
            {
                //Vote
                if((ActivityTypeFlag)CurrentActivity.ActivityTypeID == ActivityTypeFlag.Vote)
                    listPlayers = Business.GetPlayerEntities(RoleFlag.Civilian | RoleFlag.Killer | RoleFlag.Police, IsActiveFlag.Active, CurrentGame);
                    //Killing
                else if ((ActivityTypeFlag)CurrentActivity.ActivityTypeID == ActivityTypeFlag.Kill)
                    listPlayers = Business.GetPlayerEntities(RoleFlag.Killer, IsActiveFlag.Active, CurrentGame);
                    //Investigating
                else
                    listPlayers = Business.GetPlayerEntities(RoleFlag.Police, IsActiveFlag.Active, CurrentGame);

                //CurrentActivity = Business.CreateNewActivity(CurrentGame);
                CurrentActivity.RoundCount++;
                VoteResult voteResult = new VoteResult();
                foreach (PlayerEntity play in listPlayers)
                {
                    SendMessageThread(play.IP, "Judger says: This round is invalid, please vote again!");

                    proxyClientHost = ConnectToServer(play.IP);
                    voteResult.KilledPlayer = null;
                    voteResult.IsThisVoteValid = false;
                    voteResult.TimeFlag = GetCurrentTimeFlag();
                    voteResult.ActiveTypeFlag = GetNextActivityType(false);
                    proxyClientHost.ReceiveVoteResult(voteResult);
                }
                //, (ActivityTypeFlag)CurrentActivity.ActivityTypeID);
            }
            #endregion
            return true;
        }


        //Return the next activity type based on current activity type and whethere current activity is completed(success);
        private ActivityTypeFlag GetNextActivityType(bool bCurrentFinished)
        {
            if (!bCurrentFinished)
                return (ActivityTypeFlag)CurrentActivity.ActivityTypeID;

            if ((ActivityTypeFlag)CurrentActivity.ActivityTypeID == ActivityTypeFlag.Vote)
                return ActivityTypeFlag.Kill;
            else if ((ActivityTypeFlag)CurrentActivity.ActivityTypeID == ActivityTypeFlag.Kill)
                return ActivityTypeFlag.Investigate;
            else
                return ActivityTypeFlag.Vote;

        }

        //Player client -> Server host
        //The return list is the player list currently already logon.
        [OperationBehavior]
        public List<string> Logon(LogonFormat logon)
        {
            MessageDistribution proxyClientHost = null;
            GameInfo gameInfo = new GameInfo();
            IList<string> listPlayers = new List<string>();
            IList<string> listKillers = new List<string>();
            IList<string> listCivilians = new List<string>();

            //If game already start, logon failed.
            if (CurrentGame != null)
            {
                //ConnectToServer(logon.IPPortServiceString).ReceiveNewsMsg("Judger says: Game already start, please wait to next round!");
                return null;
            }

            List<string> listPlayerIDs = new List<string>();

            //Save player into database
            User playerLogon = new User();
            playerLogon.IP = logon.IPPortServiceString;
            playerLogon.UserID = logon.LogonPerson;
            playerLogon.Name = logon.LogonPerson;
            playerLogon.Password = logon.LogonPerson;
            Business.Logon(playerLogon);

            //Broadcast to all person that this guy comes.
            

            IList<User> listPlayesOnline = Business.GetUser(IsOnlineFlag.Online);
            //Server log.n
            Console.WriteLine(logon.LogonPerson + " comes online!");

            //Determine if the game should start
            //Here need to be configurable
            if (listPlayesOnline.Count >= MessageDistribute.AllPlayersCount)
            {
                //lanuch game
                CurrentGame = Business.CreateNewGame();
                CurrentActivity = Business.CreateNewActivity(CurrentGame);
                IList<PlayerEntity> listPlayerEnities = Business.GetPlayerEntities(RoleFlag.Civilian | RoleFlag.Killer | RoleFlag.Police, IsActiveFlag.Active | IsActiveFlag.Dead, CurrentGame);
                foreach (PlayerEntity player in listPlayerEnities)
                {
                    listPlayers.Add(player.UserID);

                    if (player.RoleID == (int)RoleFlag.Killer)
                        listKillers.Add(player.UserID);
                    else if (player.RoleID == (int)RoleFlag.Civilian)
                        listCivilians.Add(player.UserID);

                    SendMessageThread(player.IP, "Judger says: " + playerLogon.UserID + " comes online!");
                    //proxyClientHost = ConnectToServer(player.IP);
                    ////proxyClientHost.ReceiveNewsMsg("Judger says: " + playerLogon.PlayerID + " comes online!");

                }
                
                gameInfo.listKillers = listKillers.ToArray();
                gameInfo.listPlayers = listPlayers.ToArray();
                gameInfo.listPolicemen = null;
                IList<PlayerEntity> listPlayerEntities = Business.GetPlayerEntities(RoleFlag.Civilian | RoleFlag.Killer | RoleFlag.Police, IsActiveFlag.Active, CurrentGame);


                foreach (PlayerEntity player in listPlayerEntities)
                {
                    proxyClientHost = ConnectToServer(player.IP);
                    SendMessageThread(player.IP, "Judger says: Game start, vote to the person you think he(she) is a killer, everyone can only vote once, let's go!");
                    //proxyClientHost.ReceiveNewsMsg("Judger says: Game start, vote to the person you think he(she) is a killer, everyone can only vote once, let's go!");

                    gameInfo.YourRole = (RoleFlag)player.RoleID;
                    proxyClientHost.GameStart(gameInfo);
                }
            }

            //return the current logon players.
            return listPlayerIDs;
        }

        //connect to server, when server host works as a client, this will be used.
        private MessageDistribution ConnectToServer(string strEndPointAddr)
        {
            NetTcpBinding tcpBinding = new NetTcpBinding();
            tcpBinding.TransactionFlow = false;
            tcpBinding.Security.Transport.ProtectionLevel =
              System.Net.Security.ProtectionLevel.EncryptAndSign;
            tcpBinding.Security.Transport.ClientCredentialType =
              TcpClientCredentialType.Windows;
            tcpBinding.Security.Mode = SecurityMode.None;

            EndpointAddress endpointAddress =
                new EndpointAddress(strEndPointAddr);


            
            MessageDistribution proxy =
            ChannelFactory<MessageDistribution>.CreateChannel(tcpBinding, endpointAddress);
            
            return proxy;
        }
    }

    [DataContract]
    public class VoteFormat
    {
        [DataMember]
        public string Voter { get; set; }

        [DataMember]
        public string Condidate { get; set; }

        //Time flag, indicate daytime or night
        [DataMember]
        public TimeFlag TimeFlag { get; set; }

        [DataMember]
        public int GameNo{get; set;}

        //The server ip address to send message
        [DataMember]
        public string EndpointAddress{get; set;}
    }

    [DataContract]
    public class ChatFormat
    {
        //ID
        [DataMember]
        public string Sender { get; set; }

        [DataMember]
        public string MsgBody { get; set; }

        //TODO:When chat one to one
        //"" if this message is not to a given person
        [DataMember]
        public string Receipter { get; set; }

        //Time flag, indicate daytime or night
        [DataMember]
        public TimeFlag TimeFlag { get; set; }

        [DataMember]
        public int GameNo{get; set;}

        //The server ip address to send message
        [DataMember]
        public string EndpointAddress{get; set;}
    }

    [DataContract]
    public class LogonFormat
    {
        [DataMember]
        public string LogonPerson { get; set; }

        [DataMember]
        public string IPPortServiceString { get; set; }
    }
}
